#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAX_STUD 1000
#define MAX_IME 51

typedef struct _student{
	char ime[MAX_IME];
	char prezime[MAX_IME];
	int ocena;
}student;

//radicemo nesto vise, da bude sortirano po oceni, 
//ali ako su ocene iste, onda po prezimenu, pa po imenu

void greska(){
	printf("-1\n");
	exit(EXIT_FAILURE);
}

int poredi(const void *a, const void *b){
	//prvo gledamo ocene,
	//ako su iste gledamo prezime
	//ako je i prezime isto poredimo ime
	
	student *sa = (student*)a;
	student *sb = (student*)b;
	
	int cmp_ocena = sa->ocena - sb->ocena;
	if(cmp_ocena) //cmp_ocena != 0, tj nisu isti
		return cmp_ocena;
	
	int cmp_prezime = strcmp(sa->prezime, sb->prezime);
	if(cmp_prezime)
		return cmp_prezime;
	
	return strcmp(sa->ime, sb->ime);
}


int main(int argc, char **argv){
	//proveravamo da li je dobar broj arg. kom. lin.
	if(argc != 2)
		greska();
	
	FILE *f = fopen(argv[1], "r");
	if(f == NULL)
		greska();
	
	//citamo studente iz datoteke, dok ne dodjemo do kraja...
	char temp_ime[MAX_IME];
	char temp_prezime[MAX_IME];
	char temp_ocena;
	
	student studenti[MAX_STUD];
	int n_studenti = 0;
	
	while(fscanf(f, "%s%s%d",
		temp_ime, temp_prezime, &temp_ocena) == 3){
	
		printf("%s\n", temp_prezime);
	
		n_studenti++;
		
		if(n_studenti > MAX_STUD)
			greska();
		
		strcpy(studenti[n_studenti-1].ime, temp_ime);
		strcpy(studenti[n_studenti-1].prezime, temp_prezime);
		studenti[n_studenti-1].ocena = temp_ocena;
	}
	
	fclose(f);
	
	qsort(studenti, n_studenti, sizeof(student), poredi);
	int i;
	for(i = 0; i < n_studenti; i++){
		printf("%s %s %d\n", 
			studenti[i].prezime, 
			studenti[i].ime, 
			studenti[i].ocena);
	}
	
}